gpio: rcar: Fix runtime PM imbalance on error
[linux/fpc-iii.git] / tools / lib / bpf / Makefile
blobaee7f1a83c7755cfd4966cd190350b035bb789e4
1 # SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
2 # Most of this file is copied from tools/lib/traceevent/Makefile
4 LIBBPF_VERSION := $(shell \
5 grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | \
6 sort -rV | head -n1 | cut -d'_' -f2)
7 LIBBPF_MAJOR_VERSION := $(firstword $(subst ., ,$(LIBBPF_VERSION)))
9 MAKEFLAGS += --no-print-directory
11 # This will work when bpf is built in tools env. where srctree
12 # isn't set and when invoked from selftests build, where srctree
13 # is a ".". building_out_of_srctree is undefined for in srctree
14 # builds
15 ifndef building_out_of_srctree
16 srctree := $(patsubst %/,%,$(dir $(CURDIR)))
17 srctree := $(patsubst %/,%,$(dir $(srctree)))
18 srctree := $(patsubst %/,%,$(dir $(srctree)))
19 #$(info Determined 'srctree' to be $(srctree))
20 endif
22 INSTALL = install
24 # Use DESTDIR for installing into a different root directory.
25 # This is useful for building a package. The program will be
26 # installed in this directory as if it was the root directory.
27 # Then the build tool can move it later.
28 DESTDIR ?=
29 DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'
31 include $(srctree)/tools/scripts/Makefile.arch
33 ifeq ($(LP64), 1)
34 libdir_relative = lib64
35 else
36 libdir_relative = lib
37 endif
39 prefix ?= /usr/local
40 libdir = $(prefix)/$(libdir_relative)
41 man_dir = $(prefix)/share/man
42 man_dir_SQ = '$(subst ','\'',$(man_dir))'
44 export man_dir man_dir_SQ INSTALL
45 export DESTDIR DESTDIR_SQ
47 include $(srctree)/tools/scripts/Makefile.include
49 # copy a bit from Linux kbuild
51 ifeq ("$(origin V)", "command line")
52 VERBOSE = $(V)
53 endif
54 ifndef VERBOSE
55 VERBOSE = 0
56 endif
58 FEATURE_USER = .libbpf
59 FEATURE_TESTS = libelf libelf-mmap zlib bpf reallocarray
60 FEATURE_DISPLAY = libelf zlib bpf
62 INCLUDES = -I. -I$(srctree)/tools/include -I$(srctree)/tools/arch/$(ARCH)/include/uapi -I$(srctree)/tools/include/uapi
63 FEATURE_CHECK_CFLAGS-bpf = $(INCLUDES)
65 check_feat := 1
66 NON_CHECK_FEAT_TARGETS := clean TAGS tags cscope help
67 ifdef MAKECMDGOALS
68 ifeq ($(filter-out $(NON_CHECK_FEAT_TARGETS),$(MAKECMDGOALS)),)
69 check_feat := 0
70 endif
71 endif
73 ifeq ($(check_feat),1)
74 ifeq ($(FEATURES_DUMP),)
75 include $(srctree)/tools/build/Makefile.feature
76 else
77 include $(FEATURES_DUMP)
78 endif
79 endif
81 export prefix libdir src obj
83 # Shell quotes
84 libdir_SQ = $(subst ','\'',$(libdir))
85 libdir_relative_SQ = $(subst ','\'',$(libdir_relative))
87 OBJ = $@
88 N =
90 LIB_TARGET = libbpf.a libbpf.so.$(LIBBPF_VERSION)
91 LIB_FILE = libbpf.a libbpf.so*
92 PC_FILE = libbpf.pc
94 # Set compile option CFLAGS
95 ifdef EXTRA_CFLAGS
96 CFLAGS := $(EXTRA_CFLAGS)
97 else
98 CFLAGS := -g -Wall
99 endif
101 ifeq ($(feature-libelf-mmap), 1)
102 override CFLAGS += -DHAVE_LIBELF_MMAP_SUPPORT
103 endif
105 ifeq ($(feature-reallocarray), 0)
106 override CFLAGS += -DCOMPAT_NEED_REALLOCARRAY
107 endif
109 # Append required CFLAGS
110 override CFLAGS += $(EXTRA_WARNINGS)
111 override CFLAGS += -Werror -Wall
112 override CFLAGS += -fPIC
113 override CFLAGS += $(INCLUDES)
114 override CFLAGS += -fvisibility=hidden
115 override CFLAGS += -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
117 # flags specific for shared library
118 SHLIB_FLAGS := -DSHARED
120 ifeq ($(VERBOSE),1)
122 else
123 Q = @
124 endif
126 # Disable command line variables (CFLAGS) override from top
127 # level Makefile (perf), otherwise build Makefile will get
128 # the same command line setup.
129 MAKEOVERRIDES=
131 all:
133 export srctree OUTPUT CC LD CFLAGS V
134 include $(srctree)/tools/build/Makefile.include
136 SHARED_OBJDIR := $(OUTPUT)sharedobjs/
137 STATIC_OBJDIR := $(OUTPUT)staticobjs/
138 BPF_IN_SHARED := $(SHARED_OBJDIR)libbpf-in.o
139 BPF_IN_STATIC := $(STATIC_OBJDIR)libbpf-in.o
140 VERSION_SCRIPT := libbpf.map
141 BPF_HELPER_DEFS := $(OUTPUT)bpf_helper_defs.h
143 LIB_TARGET := $(addprefix $(OUTPUT),$(LIB_TARGET))
144 LIB_FILE := $(addprefix $(OUTPUT),$(LIB_FILE))
145 PC_FILE := $(addprefix $(OUTPUT),$(PC_FILE))
147 TAGS_PROG := $(if $(shell which etags 2>/dev/null),etags,ctags)
149 GLOBAL_SYM_COUNT = $(shell readelf -s --wide $(BPF_IN_SHARED) | \
150 cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' | \
151 sed 's/\[.*\]//' | \
152 awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}' | \
153 sort -u | wc -l)
154 VERSIONED_SYM_COUNT = $(shell readelf -s --wide $(OUTPUT)libbpf.so | \
155 grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 | sort -u | wc -l)
157 CMD_TARGETS = $(LIB_TARGET) $(PC_FILE)
159 all: fixdep
160 $(Q)$(MAKE) all_cmd
162 all_cmd: $(CMD_TARGETS) check
164 $(BPF_IN_SHARED): force elfdep zdep bpfdep $(BPF_HELPER_DEFS)
165 @(test -f ../../include/uapi/linux/bpf.h -a -f ../../../include/uapi/linux/bpf.h && ( \
166 (diff -B ../../include/uapi/linux/bpf.h ../../../include/uapi/linux/bpf.h >/dev/null) || \
167 echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf.h' differs from latest version at 'include/uapi/linux/bpf.h'" >&2 )) || true
168 @(test -f ../../include/uapi/linux/bpf_common.h -a -f ../../../include/uapi/linux/bpf_common.h && ( \
169 (diff -B ../../include/uapi/linux/bpf_common.h ../../../include/uapi/linux/bpf_common.h >/dev/null) || \
170 echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf_common.h' differs from latest version at 'include/uapi/linux/bpf_common.h'" >&2 )) || true
171 @(test -f ../../include/uapi/linux/netlink.h -a -f ../../../include/uapi/linux/netlink.h && ( \
172 (diff -B ../../include/uapi/linux/netlink.h ../../../include/uapi/linux/netlink.h >/dev/null) || \
173 echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/netlink.h' differs from latest version at 'include/uapi/linux/netlink.h'" >&2 )) || true
174 @(test -f ../../include/uapi/linux/if_link.h -a -f ../../../include/uapi/linux/if_link.h && ( \
175 (diff -B ../../include/uapi/linux/if_link.h ../../../include/uapi/linux/if_link.h >/dev/null) || \
176 echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_link.h' differs from latest version at 'include/uapi/linux/if_link.h'" >&2 )) || true
177 @(test -f ../../include/uapi/linux/if_xdp.h -a -f ../../../include/uapi/linux/if_xdp.h && ( \
178 (diff -B ../../include/uapi/linux/if_xdp.h ../../../include/uapi/linux/if_xdp.h >/dev/null) || \
179 echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_xdp.h' differs from latest version at 'include/uapi/linux/if_xdp.h'" >&2 )) || true
180 $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(SHARED_OBJDIR) CFLAGS="$(CFLAGS) $(SHLIB_FLAGS)"
182 $(BPF_IN_STATIC): force elfdep zdep bpfdep $(BPF_HELPER_DEFS)
183 $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(STATIC_OBJDIR)
185 $(BPF_HELPER_DEFS): $(srctree)/tools/include/uapi/linux/bpf.h
186 $(QUIET_GEN)$(srctree)/scripts/bpf_helpers_doc.py --header \
187 --file $(srctree)/tools/include/uapi/linux/bpf.h > $(BPF_HELPER_DEFS)
189 $(OUTPUT)libbpf.so: $(OUTPUT)libbpf.so.$(LIBBPF_VERSION)
191 $(OUTPUT)libbpf.so.$(LIBBPF_VERSION): $(BPF_IN_SHARED)
192 $(QUIET_LINK)$(CC) $(LDFLAGS) \
193 --shared -Wl,-soname,libbpf.so.$(LIBBPF_MAJOR_VERSION) \
194 -Wl,--version-script=$(VERSION_SCRIPT) $^ -lelf -lz -o $@
195 @ln -sf $(@F) $(OUTPUT)libbpf.so
196 @ln -sf $(@F) $(OUTPUT)libbpf.so.$(LIBBPF_MAJOR_VERSION)
198 $(OUTPUT)libbpf.a: $(BPF_IN_STATIC)
199 $(QUIET_LINK)$(RM) $@; $(AR) rcs $@ $^
201 $(OUTPUT)libbpf.pc:
202 $(QUIET_GEN)sed -e "s|@PREFIX@|$(prefix)|" \
203 -e "s|@LIBDIR@|$(libdir_SQ)|" \
204 -e "s|@VERSION@|$(LIBBPF_VERSION)|" \
205 < libbpf.pc.template > $@
207 check: check_abi
209 check_abi: $(OUTPUT)libbpf.so
210 @if [ "$(GLOBAL_SYM_COUNT)" != "$(VERSIONED_SYM_COUNT)" ]; then \
211 echo "Warning: Num of global symbols in $(BPF_IN_SHARED)" \
212 "($(GLOBAL_SYM_COUNT)) does NOT match with num of" \
213 "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
214 "Please make sure all LIBBPF_API symbols are" \
215 "versioned in $(VERSION_SCRIPT)." >&2; \
216 readelf -s --wide $(BPF_IN_SHARED) | \
217 cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' | \
218 sed 's/\[.*\]//' | \
219 awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}'| \
220 sort -u > $(OUTPUT)libbpf_global_syms.tmp; \
221 readelf -s --wide $(OUTPUT)libbpf.so | \
222 grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 | \
223 sort -u > $(OUTPUT)libbpf_versioned_syms.tmp; \
224 diff -u $(OUTPUT)libbpf_global_syms.tmp \
225 $(OUTPUT)libbpf_versioned_syms.tmp; \
226 rm $(OUTPUT)libbpf_global_syms.tmp \
227 $(OUTPUT)libbpf_versioned_syms.tmp; \
228 exit 1; \
231 define do_install_mkdir
232 if [ ! -d '$(DESTDIR_SQ)$1' ]; then \
233 $(INSTALL) -d -m 755 '$(DESTDIR_SQ)$1'; \
235 endef
237 define do_install
238 if [ ! -d '$(DESTDIR_SQ)$2' ]; then \
239 $(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2'; \
240 fi; \
241 $(INSTALL) $1 $(if $3,-m $3,) '$(DESTDIR_SQ)$2'
242 endef
244 install_lib: all_cmd
245 $(call QUIET_INSTALL, $(LIB_TARGET)) \
246 $(call do_install_mkdir,$(libdir_SQ)); \
247 cp -fpR $(LIB_FILE) $(DESTDIR)$(libdir_SQ)
249 install_headers: $(BPF_HELPER_DEFS)
250 $(call QUIET_INSTALL, headers) \
251 $(call do_install,bpf.h,$(prefix)/include/bpf,644); \
252 $(call do_install,libbpf.h,$(prefix)/include/bpf,644); \
253 $(call do_install,btf.h,$(prefix)/include/bpf,644); \
254 $(call do_install,libbpf_util.h,$(prefix)/include/bpf,644); \
255 $(call do_install,libbpf_common.h,$(prefix)/include/bpf,644); \
256 $(call do_install,xsk.h,$(prefix)/include/bpf,644); \
257 $(call do_install,bpf_helpers.h,$(prefix)/include/bpf,644); \
258 $(call do_install,$(BPF_HELPER_DEFS),$(prefix)/include/bpf,644); \
259 $(call do_install,bpf_tracing.h,$(prefix)/include/bpf,644); \
260 $(call do_install,bpf_endian.h,$(prefix)/include/bpf,644); \
261 $(call do_install,bpf_core_read.h,$(prefix)/include/bpf,644);
263 install_pkgconfig: $(PC_FILE)
264 $(call QUIET_INSTALL, $(PC_FILE)) \
265 $(call do_install,$(PC_FILE),$(libdir_SQ)/pkgconfig,644)
267 install: install_lib install_pkgconfig
269 ### Cleaning rules
271 config-clean:
272 $(call QUIET_CLEAN, config)
273 $(Q)$(MAKE) -C $(srctree)/tools/build/feature/ clean >/dev/null
275 clean:
276 $(call QUIET_CLEAN, libbpf) $(RM) -rf $(CMD_TARGETS) \
277 *~ .*.d .*.cmd LIBBPF-CFLAGS $(BPF_HELPER_DEFS) \
278 $(SHARED_OBJDIR) $(STATIC_OBJDIR) \
279 $(addprefix $(OUTPUT), \
280 *.o *.a *.so *.so.$(LIBBPF_MAJOR_VERSION) *.pc)
281 $(call QUIET_CLEAN, core-gen) $(RM) $(OUTPUT)FEATURE-DUMP.libbpf
285 PHONY += force elfdep zdep bpfdep cscope tags
286 force:
288 elfdep:
289 @if [ "$(feature-libelf)" != "1" ]; then echo "No libelf found"; exit 1 ; fi
291 zdep:
292 @if [ "$(feature-zlib)" != "1" ]; then echo "No zlib found"; exit 1 ; fi
294 bpfdep:
295 @if [ "$(feature-bpf)" != "1" ]; then echo "BPF API too old"; exit 1 ; fi
297 cscope:
298 ls *.c *.h > cscope.files
299 cscope -b -q -I $(srctree)/include -f cscope.out
301 tags:
302 rm -f TAGS tags
303 ls *.c *.h | xargs $(TAGS_PROG) -a
305 # Declare the contents of the .PHONY variable as phony. We keep that
306 # information in a variable so we can use it in if_changed and friends.
307 .PHONY: $(PHONY)
309 # Delete partially updated (corrupted) files on error
310 .DELETE_ON_ERROR: